local _, cClass = UnitClass("player")

if (cClass ~= "DRUID") then
	return
end

--QuartzProc = LibStub("AceAddon-3.0"):GetAddon("QuartzProc")
local QuartzProc = Quartz:GetModule('Procs')

function QuartzProc:returnProcList()
local tmpList = {
		[48517] = { -- Wrath Eclipse
			-- Wrath + Eclipse
			name = GetSpellInfo(48461) .. " ".. GetSpellInfo(48517),
			--name = GetSpellInfo(48517),
			color = {1, 0.5, 0}, -- orange-ish
			--length = 15,
			cooldown = 30,
			expires = 0, -- patch 3.3 workaround fix
			isAura = true, -- patch 3.3 workaround fix
		},
		
		[48518] = { -- Starfire Eclipse
			-- Starfire + Eclipse		
			name = GetSpellInfo(48465) .. " ".. GetSpellInfo(48518),
			--name = GetSpellInfo(48517),
			color = {0, 0.5, 1}, -- blue-ish
			--length = 15,
			cooldown = 30,
			expires = 0, -- patch 3.3 workaround fix
			isAura = true, -- patch 3.3 workaround fix
		},
		[22812] = { -- Barkskin
			name = GetSpellInfo(22812),
			color = {0, 1, 0}, -- green
			length = 12,
		},
		[29166] = { -- Innervate
			name = GetSpellInfo(29166),
			color = {0, 0, 1}, -- blue
			length = 10,
		},
		[48391] = { -- Owklin Frenzy
			name = GetSpellInfo(48391),
			color = {0.7, 0.1, 0.1},
			length = 10,
		},
		[GetSpellInfo(53198)] = { -- StarFall
			name = GetSpellInfo(53198),
			color = {0.125, 0.698, 0.686},
			--length = 10,
			expires = 0,
			isAura = true,
			useName = true, -- v3.0 (need to put this so it works for all ranks,
							-- also name has to match exactly what the buff's actual name is)
		},
		[33831] = { -- Force of Nature
			name = GetSpellInfo(33831),
			color = {0.871, 0.721, 0.529},
			length = 30,
			isSpellCast = true,
		},
		[50334] = { -- Berserk
			name = GetSpellInfo(50334),
			color = {1, 0, 0}, -- red
			length = 15,
		},
		[50213] = { -- Tiger's Fury
			name = GetSpellInfo(50213),
			color = {1, 0, 0}, -- red
			length = 6,
		},
		[5229] = { -- Enrage
			name = GetSpellInfo(5229),
			color = {1, 0, 0}, -- red
			length = 10,
		},
		[22842] = { -- Frenzied Regen
			name = GetSpellInfo(22842),
			color = {0, 1, 0}, -- green
			length = 10,
		},
		[33357] = { -- Cat Dash
			name = GetSpellInfo(33357),
			color = {0, 1, 0}, -- green
			length = 15,
		},
		[64823] = { -- Elune's Wrath (Balance T8 4pc bonus proc)
			name = GetSpellInfo(64823),
			color = {0, 0, 1}, -- 
			length = 10,
		},
		[61336] = { -- Survival Instincts
			name = GetSpellInfo(61336),
			color = {1, 0, 0}, -- red
			length = 20,
		},
		
		[16870] = { -- Clearcasting (From Omen of Clarity)
			name = GetSpellInfo(16870),
			color = {0, 0, 1}, -- blue
			length = 15,
		},
		
		--Druid: Savage Roar
		[52610] = {
			name = GetSpellInfo(52610),
			color = {1, 0.5, 0}, -- orange-ish
			expires = 0, -- placeholder for expiration time (dont need to include length here)
			isAura = true,
		},

		[69369] = { -- Predator's Swiftness (instant cast nature spell)
			name = GetSpellInfo(69369),
			color = {0.47, 1, 0.298}, -- light-green
			length = 8,
		},
		
		-- relics
		[67360] = { -- Druid T9 Balance Relic (Moonfire)
			name = GetSpellInfo(67360),
			color = {0, 0, 1}, -- blue
			length = 12,
		},
		[67358] = { -- Druid T9 Restoration Relic (Rejuvenation)
			name = GetSpellInfo(67358),
			color = {0, 0, 1}, -- blue
			length = 9,
		},
		
		-- T10 procs
		[70721] = { -- Omen of Doom 
			name = GetSpellInfo(70721), 
			color = {0, 0, 1}, -- blue
			length = 6, 
		}, 
		[71023] = { -- Languish 
			name = GetSpellInfo(71023), 
			color = {0, 0, 1}, --blue
			length = 4, 
		},
		
		
		[53414] = { -- Elemental oath (buff from shammy) (Added v2.2)
			name = GetSpellInfo(53414),
			color = {0.25, 0.5, 0.75}, -- light blue
			length = 15,
			optionsOrder = 600,
			ptype = 'general',
		}
}

return tmpList
end