local _, cClass = UnitClass("player")

if (cClass ~= "PRIEST") then
	return
end

local QuartzProc = Quartz:GetModule('Procs')

function QuartzProc:returnProcList()
local tmpList = {
		[33154] = { -- Surge of light
			name = GetSpellInfo(33154),
			color = {0.93, 0.98, 0.51}, -- Light-Goldenrod
			expires = 0,
			isAura = true,
			useName = true,
		},
		[33206] = { -- Pain Supression
			name = GetSpellInfo(33206),
			color = {0, 0.5, 1}, -- blue-ish
			expires = 0,
			isAura = true,
		},
		[10060] = { -- Power Infusion
			name = GetSpellInfo(10060),
			color = {1, 0, 0.5}, --purple-ish
			expires = 0,
			isAura = true,
		},
		[59000] = { -- Spirit Tap
			name = GetSpellInfo(59000),
			color = {1, 0.5, 0}, -- orange-ish
			expires = 0,
			isAura = true,
		},
		[6788] = { -- Weakened Soul (TODO: Fix: Doesnt work with pvp set bonus reduction)
			name = GetSpellInfo(6788),
			color = {1, 0, 0}, -- red
			length = 15,
		},
		[59891] = { -- Borrowed Time
			name = GetSpellInfo(59891),
			color = {1, 0.5, 0}, -- orange-ish
			length = 6,
		},
		[63944] = { -- Renewed Hope
			name = GetSpellInfo(63944),
			color = {0.93, 0.98, 0.51}, -- Light-Goldenrod
			length = 20,
		},
		[63731] = { -- Serendipity (1/3) *Added v2.2*
			name = GetSpellInfo(63734),
			color = {0, 0.25, 1}, -- blue-ish
			length = 20,
			isStack = true,
			oldname = "",
			link = 1, -- only link 1 gets added to options
			linked = {63731,63735,63734}, -- options are changed for all these spell ids
		},
		[63735] = { -- Serendipity (2/3) *Added v2.2*
			name = GetSpellInfo(63734),
			color = {0, 0.25, 1}, -- blue-ish
			length = 20,
			isStack = true,
			oldname = "",
			link = 2,
			linked = {63731,63735,63734},
		},
		[63734] = { -- Serendipity (3/3) *Added v2.2*
			name = GetSpellInfo(63734),
			color = {0, 0.25, 1}, -- blue-ish
			length = 20,
			isStack = true,
			oldname = "",
			link = 3,
			linked = {63731,63735,63734},
		},
		[47788] = { -- Guardian Spirit
			name = GetSpellInfo(47788),
			color = {0.25, 0.5, 0.75}, -- light blue
			length = 10,
			isSpellCast = true,
		},
		
		[48168] = { -- Inner Fire
			name = GetSpellInfo(48168),
			color = {0.4, 0.4, 0}, -- red-brown
			length = 30*60,
			isSpellCast = true,
		},
		[15332] = { -- Shadow Weaving *untested* (Added v2.2)
			name = GetSpellInfo(15332),
			color = {1, 0, 0.5}, --purple-ish
			length = 20,
			isStack = true,
			oldname = "",
		},
		
		[53414] = { -- Elemental oath (buff from shammy) (Added v2.2)
			name = GetSpellInfo(53414),
			color = {0.25, 0.5, 0.75}, -- light blue
			length = 15,
			optionsOrder = 600,
			ptype = 'general',
		}
}
return tmpList
end