--local L = AceLibrary("AceLocale-2.2"):new("Quartz_Procs")
--
--
--[[
* TODO: 
* more sounds!
* warlock: insta shadowbolt, incinerate, nether protection

** v3.0.4r **
-Bug fixes

*** v3.0.3r ***
-Custom procs sounds
-Changed Predator's Swiftness default color
-Changed clearcasting for shaman to isAura (should fix it)
-Added an update message that will display the new command to open config
-Various bug fixes

*** v3.0.2b ***
-Fixed the sounds up... it uses SharedMedia Lib 3.0 now. If you don't have SharedMedia then it will
have some blizz sounds, not as many as SharedMedia (but I'll add more eventually)
-Fixed some issues with the table keys being numbers, they're all converted to strings in the
database now. Using numbers in the class proc/buff files isn't a problem
-Removed Misdirection from general, it doesn't seem to be a buff on the target anymore (only self)

TODO:
-Add sounds for custom spells (not hard to do... just been busy with other stuff)
-Possibly find a better way to deal with useName and it working with sounds
It works okay for now but you have to do [GetSpellInfo(<spellid>)] = { useName = true }
But there's certain issues that may crop up (or not... it depends)
Need a way to support all ranks of a spell without having to use the 'useName' fix (i think!)
-Need to either make the duration shorter or find a way to start a timer counting down from a 
different value, the reason, if you add a custom spell (like thorns) and you already have thorns
on you, then it's gonna put it as 10min even if it's at like 4min, i believe the same problem 
happens when you zone in/out too
-Delete a custom proc... make sure it deletes the timer if it's still going? (only useful
for long buffs)


*** v3.0.1b ***
-You can now add custom procs by name only
-Updated the configuration for Adding custom procs. By default it will add by name but
there's a toggle to add by spell ID (the only difference would be that adding by spell ID
means you can change the name, which isn't something that's really a great feature anyways)
-Fixed bug that was giving a nil error for custom table in the database
-Fixed sacred shield (again)
-Fixed all the table keys for the ProcsList to be strings, seems it was the only way to 
solve the problem of having custom procs by name only and not spellID


*** v3.0b ***
-New configuration. Uses Ace3 and config is added to blizzard's addon manager
-New slashs commands /procs and /quartzprocs (for opening the config)
-Class procs and General procs seperated now
-New custom procs
-Sounds for procs
-Cleaned up configuration code a bit (still needs alot more attention)
-New code for UNIT_AURA event. Watches for buffs/procs that gets removed
(this was needed for the workarounds for the combatlog bug, but its a nice feature to have anyways)

Spells
-Added Arcane Blast debuff (turned off by default)
-Added Druid T10 Procs (OoD, Languish)
-Added Verdict rings
-Predatory Strikes length fixed

WorkArounds (spells that are fixed now)
-Eclipse
-Missile Barrage
-Brain Freeze
-Hot Streak
-Bloodsurge
-Sword and Board
-Slam! (Triggered by Bloodsurge)

TODO:
(done)-Sacred shield should be working fine now... still have to check for the talent :(
(done)-Lots more testing needed for custom procs... it should work with stacking buffs/procs
however, it doesn't display the stacks as of yet, also it now works with just using the name
of the buff, so there's no need for spellID

-Move the configuration into a seperate addon... i'll do this when i get motivated enough
to optimize the code :)

(done)-Make sure all the workarounds are in place (could have missed a few)
-Customize cooldown bars (color, name?, add icon?)


*** v2.2 ***
seperated class data into it's own file
changed options around, you can only configure the options of the current class you are using
- (i want to change this so it has categories for each class, like for druid... Feral, Balance, Resto, etc)
optionsOrder added so you can put the general options on the bottom of the list
link and linked added
- link 1 controls all the linked items (for the options)
elemental oath added (and disabled by default)
--]]
--

QuartzProc = LibStub("AceAddon-3.0"):NewAddon("QuartzProc", "AceConsole-3.0")

local Quartz = Quartz
if Quartz:HasModule('Procs') then
	return
end

local QuartzCustomTimer = Quartz:NewModule('Procs', 'AceHook-2.1')
local self = QuartzCustomTimer

local m = Quartz:GetModule('Mirror')
local QP = Quartz:GetModule('Player')
local ex = m.ExternalTimers
local new, del = Quartz.new, Quartz.del

local db = Quartz:AcquireDBNamespace("Procs3")

local _, curClass = UnitClass("player")
local procs_List
local spellsWatch = {}
local ProcList = {}
local CustomOptions = {}

local sharedMedia = LibStub("LibSharedMedia-3.0", true)
local useSharedMedia = false
local media = {}
	
local fproc
local tproc

-- Show a message only once!
local firstTimeShowMsgText = "|cFF00FF00Quartz: Procs|r - Updated to v3.0.3. Custom procs and sounds are available. |cFFFF0000Type /procs for options!|r"
local firstTimeShowMsg = false

procs_List = {
	General = {
		[32182] = { -- Heroism
			name = GetSpellInfo(32182),
			length = 40,
			color = {1, 0.65, 0}, -- orange
			optionsOrder = 501,
			ptype = 'general',
		},
		[2825] = { -- Bloodlust
			name = GetSpellInfo(2825),
			length = 40,
			color = {1, 0.65, 0}, -- orange
			optionsOrder = 511,
			ptype = 'general',
		},
		

		[57933] = { -- TotT, threat directed to (this) target
			name = GetSpellInfo(57933) .. " (target)",
			color = {1, 0, 0}, -- (warning) red
			length = 6,
			optionsOrder = 531,
			ptype = 'general',
		},
		
		-- Verdict Rings
		[72412] = { -- Frostforged Champion 
			name = GetSpellInfo(72412), 
			length = 10, 
			color = {1, 0.65, 0}, -- orange 
			optionsOrder = 541,
			ptype = 'general',
		}, 
		[72414] = { -- Frostforged Defender 
			name = GetSpellInfo(72414), 
			length = 10, 
			color = {1, 0.65, 0}, -- orange 
			optionsOrder = 551,
			ptype = 'general',
		}, 
		[72416] = { -- Frostforged Sage 
			name = GetSpellInfo(72416), 
			length = 10, 
			color = {1, 0.65, 0}, -- orange 
			optionsOrder = 561,
			ptype = 'general',
		}, 
		[72418] = { -- Item - Icecrown Reputation Ring Healer Effect 
			name = GetSpellInfo(72418), 
			length = 10, 
			color = {1, 0.65, 0}, -- orange 
			optionsOrder = 571,
			ptype = 'general',
		},
		
	}
}


local function getLeaf(info)
	return CustomOptions.args[info[1]]
end


function IsNumber(Value)
	if (type(Value) == "number") then
		return true
	else
		return false
	end
end



-- get the divine guardian talent (to see how long to increase sacred shield buff)
function QuartzCustomTimer:checkTalentPoints()
	if (curClass == "PALADIN") then
		nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(2,9); -- Divine Guardian
		--print("- "..nameTalent..": "..currRank.."/"..maxRank);
		spellsWatch["53601"].length = 30 + (30 *  (currRank * 0.5))
	end
end
	
-- check talent points for paladin, to update timer lengths
function QuartzCustomTimer:PLAYER_TALENT_UPDATE()
	if (curClass == "PALADIN") then
		self:checkTalentPoints()
	end
end

function QuartzCustomTimer:OnInitialize()
	Quartz:RegisterDefaults("Procs3", "profile", {
		active = true,
		["35079"] = {
			enabled = false,
		},
		["57933"] = {
			enabled = false,
		},
		["53414"] = {
			enabled = false,
		},
		["36032"] = { -- Arcane Blast
			enabled = false,
		},
	})
	
	if (db.profile.custom == nil) then
		-- one time conversion of v2 to v3 database (changing all key values to strings)
		-- TODO: remove this in a later version
		for spellKey, spellTable in pairs(db.profile) do
			db.profile[tostring(spellKey)] = spellTable
			if (db.profile[tonumber(spellKey)] ~= nil) then db.profile[tonumber(spellKey)] = nil end
		end
		db.profile.custom = {}
		firstTimeShowMsg = true
	end
	local function joinTablesNew()
		for k,v in pairs(procs_List.General) do
			--table.insert(ProcList, k, v)
			ProcList[tostring(k)] = v
		end
		-- insert all the custom spells from db into the table
		for cSpellID,cSpell in pairs(db.profile.custom) do
			--table.insert(ProcList, cSpellID, cSpell)
			ProcList[tostring(cSpellID)] = cSpell
		end

		return ProcList
	end
	
	local tmpList = self:returnProcList()
	for k, v in pairs(tmpList) do
		local tmptmpList = {}
		for nk, nv in pairs(v) do
			tmptmpList[tostring(nk)] = nv
		end
		ProcList[tostring(k)] = tmptmpList
	end
	
	--Setup the spellsWatch value to hold current table for that class
	spellsWatch = joinTablesNew()
	--
	self:checkTalentPoints()
	
	
	if (not sharedMedia) or (table.getn(sharedMedia:List("sound")) < 2) then
		useSharedMedia = false
		media = {
			["None"] = "None", 
			["Sound\\Spells\\Sunwell_Fel_PortalStand.wav"] = "Fel Portal", 
			["Sound\\Spells\\SeepingGaseous_Fel_Nova.wav"] = "Fel Nova", 
			["Sound\\Doodad\\Hellfire_Raid_FX_Explosion05.wav"] = "Explosion",
			["Sound\\Doodad\\KharazahnBellToll.wav"] = "Kara Bell Toll", 
			["Sound\\Interface\\AlarmClockWarning1.wav"] = "Alarm 1", 
			["Sound\\Interface\\AlarmClockWarning2.wav"] = "Alarm 2", 
			["Sound\\Interface\\AlarmClockWarning3.wav"] = "Alarm 3", 
			["Sound\\Spells\\YarrrrImpact.wav"] = "Yarrr",
		}
	else
		useSharedMedia = true
		for idx, sound in next, sharedMedia:List("sound") do
			media[sound] = sound
		end
	end
	
	local function set(info, value)
		local field = tostring(info.arg)
		
		if (value ~= nil) then
			if (db.profile[field] ~= nil) then
				if (spellsWatch[field].link ~= nil) then
					for i,v in ipairs(spellsWatch[field].linked) do
						local sKey = tostring(v)
						if (db.profile[sKey] == nil) then
							db.profile[sKey] = { enabled = value }
						else
							db.profile[sKey].enabled = value
						end
					end
				else
					db.profile[field].enabled = value
				end
			else
				if (spellsWatch[field].link ~= nil) then
					for i,v in ipairs(spellsWatch[field].linked) do
						local sKey = tostring(v)
						if (db.profile[sKey] == nil) then
							db.profile[sKey] = { enabled = value }
						else
							db.profile[sKey].enabled = value
						end
					end
				else
					db.profile[field] = {
						enabled = value
					}
				end
			end
		else
			if (db.profile[field] ~= nil) then
				if (spellsWatch[field].link ~= nil) then
					for i,v in ipairs(spellsWatch[field].linked) do
						local sKey = tostring(v)
						if (db.profile[sKey] == nil) then
							db.profile[sKey] = { enabled = value }
						else
							db.profile[sKey].enabled = value
						end
					end
				else
					db.profile[field].enabled = false
				end
			else
				if (spellsWatch[field].link ~= nil) then
					for i,v in ipairs(spellsWatch[field].linked) do
						local sKey = tostring(v)
						if (db.profile[sKey] == nil) then
							db.profile[sKey] = { enabled = value }
						else
							db.profile[sKey].enabled = value
						end
					end
				else
					db.profile[field] = {
						enabled = false
					}
				end
			end
		end
	end
	local function get(info)
		local field = tostring(info.arg)
		
		if db.profile[field] ~= nil and db.profile[field].enabled ~= nil then
			return db.profile[field].enabled
		else
			return true
		end
	end
	-- set color
	local function setcolor(info, ...)
		local field = tostring(info.arg)
		
		if (db.profile[field] == nil) then
			if (spellsWatch[field].link ~= nil) then
				for i,v in ipairs(spellsWatch[field].linked) do
					local sKey = tostring(v)
					if (db.profile[sKey] == nil) then
						db.profile[sKey] = { color = {...} }
					else
						db.profile[sKey].color = {...}
					end
				end
			else
				db.profile[field] = {
					color = {...}
				}
			end
		else
			if (spellsWatch[field].link ~= nil) then
				for i,v in ipairs(spellsWatch[field].linked) do
					local sKey = tostring(v)
					if (db.profile[sKey] == nil) then
						db.profile[sKey] = { color = {...} }
					else
						db.profile[sKey].color = {...}
					end
				end
			else
				db.profile[field].color = {...}
			end
		end
	end
	local function getcolor(info)
		local field = tostring(info.arg)
		
		if db.profile[field] ~= nil and db.profile[field].color ~= nil then
			return unpack(db.profile[field].color)
		elseif spellsWatch[field] then
			return unpack(spellsWatch[field].color)
		else
			error("[" .. field .. "] is nil")
			return {1,0,0}
		end
	end
	
	local function setsound(info, value)
		local field = tostring(info.arg)

		local spellsound = value
		
		if useSharedMedia then
			local playspellsound = sharedMedia:Fetch("sound", value)
			if (playspellsound ~= nil) and (playspellsound ~= "") then
				PlaySoundFile(playspellsound)
			else
				spellsound = "None"
			end
		else
			if (value ~= nil) and (value ~= "") then
				PlaySoundFile(value)
			else
				spellsound = "None"
			end
		end
		
		if (db.profile[field] == nil) then
			if (spellsWatch[field].link ~= nil) then
				for i,v in ipairs(spellsWatch[field].linked) do
					local sKey = tostring(v)
					if (db.profile[sKey] == nil) then
						db.profile[sKey] = { sound = spellsound }
					else
						db.profile[sKey].sound = spellsound
					end
				end
			else
				db.profile[field] = {
					sound = spellsound
				}
			end
		else
			if (spellsWatch[field].link ~= nil) then
				for i,v in ipairs(spellsWatch[field].linked) do
					local sKey = tostring(v)
					if (db.profile[sKey] == nil) then
						db.profile[sKey] = { sound = spellsound }
					else
						db.profile[sKey].sound = spellsound
					end
				end
			else
				db.profile[field].sound = spellsound
			end
		end
	end
	
	--custom set sound
	local function setsoundcust(info, value)
		--local field = tostring(info.arg)
		local field = getLeaf(info).arg

		local spellsound = value
		
		if useSharedMedia then
			local playspellsound = sharedMedia:Fetch("sound", value)
			if (playspellsound ~= nil) and (playspellsound ~= "") then
				PlaySoundFile(playspellsound)
			else
				spellsound = "None"
			end
		else
			if (value ~= nil) and (value ~= "") then
				PlaySoundFile(value)
			else
				spellsound = "None"
			end
		end
		
		db.profile.custom[field].sound = spellsound
	end
	
	--
	local function getsound(info)
		local field = tostring(info.arg)
		
		if ((db.profile[field] ~= nil) and (db.profile[field].sound ~= nil)) then
			return db.profile[field].sound
		elseif spellsWatch[field] then
			if (spellsWatch[field].sound ~= nil) and (spellsWatch[field].sound ~= "") then
				return spellsWatch[field].sound
			end
			return "None"
		else
			error(field.." is nil")
			return "None"
		end
	end
	
	local function setname(info, value)
		local field = tostring(info.arg)
		
		if (db.profile[field] == nil) then
			if (spellsWatch[field].link ~= nil) then
				for i,v in ipairs(spellsWatch[field].linked) do
					local sKey = tostring(v)
					if (db.profile[sKey] == nil) then
						db.profile[sKey] = { name = value }
					else
						db.profile[sKey].name = value
					end
				end
			else
				db.profile[field] = {
					name = value
				}
			end
		else
			if (spellsWatch[field].link ~= nil) then
				for i,v in ipairs(spellsWatch[field].linked) do
					local sKey = tostring(v)
					if (db.profile[sKey] == nil) then
						db.profile[sKey] = { name = value }
					else
						db.profile[sKey].name = value
					end
				end
			else
				db.profile[field].name = value
			end
		end
	end
	local function getname(info)
		local field = tostring(info.arg)
		
		if (db.profile[field] ~= nil) and (db.profile[field].name ~= nil) then
			return db.profile[field].name
		elseif spellsWatch[field] then
			return spellsWatch[field].name
		else
			error(field.." is nil")
			return "nil"
		end
	end
	
	
	
	local cTmpName, cTmpSpellID, cTmpToggle
	local cTmpColor = {0,0,0,1}
	
	local spellCustomOptions = {
		cToggle = {
			type = 'toggle',
			name = 'Enabled',
			desc = 'Enable/Disable',
			get = function(info)
				if (db.profile.custom[getLeaf(info).arg] ~= nil) then
					if (db.profile.custom[getLeaf(info).arg].enabled ~= nil) then
						return db.profile.custom[getLeaf(info).arg].enabled
					else
						return true
					end
				end
				return true
			end,
			set = function(info, v)
				if (db.profile.custom[getLeaf(info).arg] ~= nil) then
					db.profile.custom[getLeaf(info).arg].enabled = v
				end
			end,
			order = 10,
		},
		cName = {
			type = 'input',
			name = 'Name',
			get = function(info)
				if (getLeaf(info).arg == db.profile.custom[getLeaf(info).arg].name) then
					CustomOptions.args[info[1]].args[info[2]].disabled = true
				else
					CustomOptions.args[info[1]].args[info[2]].disabled = false
				end
				if (db.profile.custom[getLeaf(info).arg] ~= nil) then
					return db.profile.custom[getLeaf(info).arg].name or ''
				end
				return 'deleted'
			end,
			set = function(info, v)
				if (db.profile.custom[getLeaf(info).arg] ~= nil) then
					db.profile.custom[getLeaf(info).arg].name = v
				end
			end,
			order = 20,
		},
		cColor = {
			type = 'color',
			name = 'color',
			get = function(info)
				if (db.profile.custom[getLeaf(info).arg] ~= nil) then
					return unpack(db.profile.custom[getLeaf(info).arg].color)
				end
				return {1,0,0}
			end,
			set = function(info, ...)
				if (db.profile.custom[getLeaf(info).arg] ~= nil) then
					db.profile.custom[getLeaf(info).arg].color = {...}
				end
			end,
			order = 30,
		},
		cSpellID = {
			type = 'input',
			name = 'Spell ID',
			get = function(info)
				if (getLeaf(info).arg == db.profile.custom[getLeaf(info).arg].name) then
						return "<not used>"
				end
				return getLeaf(info).arg or '0'
			end,
			disabled = true,
			order = 40,
		},
		cSpellSound = {
			type = 'select',
			name = 'Sound',
			desc = 'Sound to make when proc occurs',
			get = function(info)
				local sKey = getLeaf(info).arg
				return db.profile.custom[sKey].sound or "None"
			end,
			set = setsoundcust,
			order = 40,
			values = media,
			arg = tostring(spellid),
		},
						
		cDelBtn = {
			type = 'execute',
			name = 'Delete',
			func = function(info)
				local sKey = getLeaf(info).arg
				print("Removed custom proc ("..sKey..")")
				db.profile.custom[sKey] = nil
				CustomOptions.args[info[1]] = nil
				spellsWatch[tostring(sKey)] = nil
			end,
			order = 50,
		},
	}

	function cAddBtnFunc(info)
		if (cTmpToggle == nil) or (cTmpToggle == false) then -- Proc by name only
			if (cTmpName ~= nil) and (cTmpName ~= "") then
				local tmpTbl = {
					name = cTmpName,
					color = cTmpColor,
					expires = 0,
					isAura = true,
					useName = true,
					ptype = 'custom',
				}
				db.profile.custom[cTmpName] = {
					name = cTmpName,
					color = cTmpColor,
					expires = 0,
					isAura = true,
					useName = true,
					ptype = 'custom',
				}
				
				spellsWatch[cTmpName] = tmpTbl
				
				CustomOptions.args[cTmpName] = {
					type = 'group',
					name = cTmpName,
					desc = cTmpName .. " (useName)",
					arg = tostring(cTmpName),
					order = 100,
					args = spellCustomOptions,
				}
				
				print("Added '"..cTmpName.."'")
			else
				print("Some fields were empty or invalid!")
			end
		else -- proc by Spell ID
			if (cTmpSpellID ~= nil) and (tonumber(cTmpSpellID) > 0) 
				and (cTmpName ~= nil) and (cTmpName ~= "") 
			then
				local tmpTbl = {
					name = cTmpName,
					color = cTmpColor,
					expires = 0,
					isAura = true,
					ptype = 'custom',
				}
				db.profile.custom[cTmpSpellID] = {
					name = cTmpName,
					color = cTmpColor,
					expires = 0,
					isAura = true,
					ptype = 'custom',
				}
				
				--table.insert(spellsWatch, cTmpSpellID, tmpTbl)
				spellsWatch[tostring(cTmpSpellID)] = tmpTbl
				CustomOptions.args[cTmpSpellID] = {
					type = 'group',
					name = cTmpName,
					desc = cTmpName .. " (" .. cTmpSpellID .. ")",
					arg = tostring(cTmpSpellID),
					order = 100,
					args = spellCustomOptions,
				}
				
				print("Added '"..cTmpName.."' ("..cTmpSpellID..")")
			else
				print("Some fields were empty or invalid!")
			end
		end
		
		cTmpName = ""
		cTmpSpellID = "0"
		cTmpToggle = false
		CustomOptions.args[info[1]].args.cSpellID.disabled = false
	end
	
	CustomOptions = {
		type = 'group',
		name = "Custom Procs",
		desc = "Custom Procs",
		args = {},
	}
	
	--Option to add new Proc
	CustomOptions.args["AddNewProc"] = {
		type = 'group',
		name = 'Add Proc',
		desc = 'Add a new proc',
		order = 1,
		args = {
			cName = {
				type = 'input',
				name = 'Name',
				get = function()
					return cTmpName or ''
				end,
				set = function(info, v)
					cTmpName = v
				end,
				usage = '',
				order = 20,
			},
			cColor = {
				type = 'color',
				name = 'color',
				get = function()
					return unpack(cTmpColor)
				end,
				set = function(info, ...)
					cTmpColor = {...}
				end,
				order = 30,
			},
			cToggleSpellID = {
				type = 'toggle',
				name = 'Proc by SpellID',
				desc = 'The proc/buff will be found by the Spell ID only. If you do it this way '..
					'then you will be able to change the name to whatever you like.',
				get = function(info)
					if (cTmpToggle ~= nil) then
						if (cTmpToggle == true) or (cTmpToggle == false) then
							return cTmpToggle
						end
					end
					return false
				end,
				set = function(info, v)
					cTmpToggle = v
					CustomOptions.args[info[1]].args.cSpellID.disabled = not v
				end,
				order = 31,
			},
			cSpellID = {
				type = 'input',
				name = 'Spell ID',
				get = function()
					return cTmpSpellID or "0"
				end,
				set = function(info, v)
					cTmpSpellID = v
				end,
				--validate = function(info, v)
					--print("Test2:: ["..v.."]")
					--return tonumber(v)
				--end,
				usage = '',
				disabled = true,
				order = 40,
			},
			cAddBtn = {
				type = 'execute',
				name = 'Add',
				func = cAddBtnFunc,
				order = 50,
			},
			cResetBtn = {
				type = 'execute',
				name = 'Reset',
				func = function(info)
					cTmpName = ""
					cTmpSpellID = "0"
					cTmpToggle = false
					CustomOptions.args[info[1]].args.cSpellID.disabled = false
				end,
				order = 60,
			},
		},
	}
	
	for spellid,spell in pairs(db.profile.custom) do
		if (spell.ptype == 'custom') then
			CustomOptions.args[tostring(spellid)] = {
				type = 'group',
				name = spell.name,
				desc = spell.name .. " (" .. spellid .. ")",
				arg = tostring(spellid),
				order = 100,
				args = spellCustomOptions,
			}
		end
	end
	-- End Custom Spell Options
	
	local spellargs = {}
	spellargs = {
		type = 'group',
		name = "Procs for "..curClass,
		desc = "Procs for "..curClass,
		args = {},
	}
	for spellid,spell in pairs(ProcList) do
		if (spell.ptype == nil) or ((spell.ptype ~= 'custom') and (spell.ptype ~= 'general')) then
			-- checking for "link" spells (ones with different ranks but are linked together cause they are the same spell essentially)
			if ((spell.link == nil) or ((spell.link ~= nil) and (spell.link == 1))) then
				spellargs.args[tostring(spellid)] = {
					type = 'group',
					name = spell.name,
					desc = spell.name,
					order = spell.optionsOrder or 1,
					args = {
						spellToggle = {
							type = 'toggle',
							name = 'Enabled',
							desc = 'Enable/Disable',
							get = get,
							set = set,
							order = 10,
							arg = tostring(spellid),
						},
						
						spellText = {
							type = 'input',
							name = spell.name,
							desc = 'name of spell',
							get = getname,
							set = setname,
							order = 20,
							arg = tostring(spellid),
						},
						
						spellColor = {
							type = 'color',
							name = 'Color',
							desc = 'color',
							get = getcolor,
							set = setcolor,
							order = 30,
							arg = tostring(spellid),
						},
						
						spellSound = {
							type = 'select',
							name = 'Sound',
							desc = 'Sound to make when proc occurs',
							get = getsound,
							set = setsound,
							order = 40,
							values = media,
							arg = tostring(spellid),
						},
					},
				}
			end
		end
	end
	

	--General Procs
	local genspellargs = {}
	genspellargs = {
		type = 'group',
		name = "Procs for General",
		desc = "Procs for General",
		args = {},
	}
	for spellid,spell in pairs(ProcList) do
		if (spell.ptype ~= nil) and (spell.ptype == 'general') then
			-- checking for "link" spells (ones with different ranks but are linked together cause they are the same spell essentially)
			if ((spell.link == nil) or ((spell.link ~= nil) and (spell.link == 1))) then
				genspellargs.args[tostring(spellid)] = {
					type = 'group',
					name = spell.name,
					desc = spell.name,
					order = spell.optionsOrder or 1,
					args = {
						spellToggle = {
							type = 'toggle',
							name = 'Enabled',
							desc = 'Enable/Disable',
							get = get,
							set = set,
							order = 10,
							arg = tostring(spellid),
						},
						
						spellText = {
							type = 'input',
							name = spell.name,
							desc = 'name of spell',
							get = getname,
							set = setname,
							order = 20,
							arg = tostring(spellid),
						},
						
						spellColor = {
							type = 'color',
							name = 'Color',
							desc = 'color',
							get = getcolor,
							set = setcolor,
							order = 30,
							arg = tostring(spellid),
						},
						
						spellSound = {
							type = 'select',
							name = 'Sound',
							desc = 'Sound to make when proc occurs',
							get = getsound,
							set = setsound,
							order = 40,
							values = media, --{["NONE"] = "None", ["SUNWELL_FEL_PORTALSTAND"] = "Sunwell_Fel_PortalStand", ["SEEPINGGASEOUS_FEL_NOVA"] = "SeepingGaseous_Fel_Nova", ["RAIDWARNING"] = "RaidWarning", ["READYCHECK"] = "ReadyCheck", ["PVPFLAGTAKENHORDEMONO"] = "PVPFlagTakenHordeMono",},
							arg = tostring(spellid),
						},
					},
				}
			end
		end
	end
	-- end General Procs config
	
	local config = LibStub("AceConfig-3.0")
	local dialog = LibStub("AceConfigDialog-3.0")
	
	config:RegisterOptionsTable("QuartzProc-Bliz", {
		name = "QuartzProc",
		type = "group",
		args = {
			help = {
				type = "description",
				name = "Quartz: Procs is module for Quartz that displays Procs/Buffs/Cooldowns on the Mirror module timer list.",
			},
		},
	})
	dialog:SetDefaultSize("QuartzProc-Bliz", 400, 400)
	dialog:AddToBlizOptions("QuartzProc-Bliz", "QuartzProc")

	
	--Current Class Procs
	config:RegisterOptionsTable("QuartzProc-Class", spellargs)
	QuartzProc.optionsFrame = dialog:AddToBlizOptions("QuartzProc-Class", "Class Procs", "QuartzProc")
	
	--General Procs
	config:RegisterOptionsTable("QuartzProc-General", genspellargs)
	dialog:AddToBlizOptions("QuartzProc-General", "General Procs", "QuartzProc")
	
	--Custom Procs
	config:RegisterOptionsTable("QuartzProc-Custom", CustomOptions)
	dialog:AddToBlizOptions("QuartzProc-Custom", "Custom Procs", "QuartzProc")


    QuartzProc:RegisterChatCommand("quartzprocs", "ChatCommand")
    QuartzProc:RegisterChatCommand("procs", "ChatCommand")
end

function QuartzProc:ChatCommand(input)
	InterfaceOptionsFrame_OpenToCategory(QuartzProc.optionsFrame)
    --if not input or input:trim() == "" then
        --InterfaceOptionsFrame_OpenToCategory(QuartzProc.optionsFrame)
    --else
        --LibStub("AceConfigCmd-3.0").HandleCommand(QuartzProc, "procs", "QuartzProc", input)
    --end
end


function QuartzCustomTimer:OnEnable()
	if db.profile["active"] then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:RegisterEvent("UNIT_AURA")
		self:RegisterEvent("PLAYER_TALENT_UPDATE")
	end
end

function QuartzCustomTimer:OnDisable()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:UnregisterEvent("UNIT_AURA")
	self:UnregisterEvent("PLAYER_TALENT_UPDATE")
end

function QuartzCustomTimer:Enable(doenable)
	if doenable then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:RegisterEvent("UNIT_AURA")
		self:RegisterEvent("PLAYER_TALENT_UPDATE")
	else
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:UnregisterEvent("UNIT_AURA")
		self:UnregisterEvent("PLAYER_TALENT_UPDATE")
	end
	db.profile["active"] = doenable
end


---------------------------------------------
--
--


function QuartzCustomTimer:createProcFrame(sID)
	fproc = CreateFrame("Frame", "ProcFrame", QP.castBarParent)
	fproc:Hide()
	fproc:SetFrameStrata("BACKGROUND")
	fproc:SetWidth(64)
	fproc:SetHeight(64)

	_,_,sIcon = GetSpellInfo(sID)
	tproc = fproc:CreateTexture("ProcTexture","BACKGROUND")
	tproc:SetTexture(sIcon)
	tproc:SetAllPoints(fproc)
	fproc.texture = tproc

	fproc:SetPoint("LEFT", 0, 0)
	fproc:Show()
end

function QuartzCustomTimer:createCustomTimer(sName, sLength, sID, sColor, isCooldown, sPlaySound)
	if (firstTimeShowMsg == true) then
		print(firstTimeShowMsgText)
		firstTimeShowMsg = false
	end
	
	local spellID = tostring(sID)
	-- TODO: this order okay? prolly
	local spellDB = db.profile[spellID] or db.profile[sName] or db.profile.custom[spellID] or db.profile.custom[sName]
	
	if (spellDB ~= nil) then
		if (spellDB.enabled == nil) or (spellDB.enabled == true) then
			local sIcon = ''
			local pColor = spellDB.color or sColor
			if (IsNumber(sID)) and (sID > 0) and (isCooldown == false) then
				_,_,sIcon = GetSpellInfo(sID)
			end
			--- make sure the color is always what is passed if its a cooldown
			if (isCooldown) then
				pColor = sColor
			end
			
			ex[sName] = {
				startTime = GetTime(),
				endTime = GetTime() + sLength,
				icon = sIcon,
				color = pColor,
			}
			m:TriggerEvent("QuartzMirror_UpdateCustom")

			-- Play a sound if found
			if (spellDB.sound ~= nil) and (spellDB.sound ~= "") 
				and (string.lower(spellDB.sound) ~= "none")
			then
				if useSharedMedia then
					local playspellsound = sharedMedia:Fetch("sound", spellDB.sound)
					if (playspellsound ~= nil) and (playspellsound ~= "") then
						PlaySoundFile(playspellsound)
					end
				else
					local playspellsound = spellDB.sound
					if (playspellsound ~= nil) and (playspellsound ~= "") then
						PlaySoundFile(playspellsound)
					end
				end
			elseif (sPlaySound ~= nil) and (sPlaySound ~= "") 
				and (string.lower(sPlaySound) ~= "none")
			then
				if useSharedMedia then
					local playspellsound = sharedMedia:Fetch("sound", sPlaySound)
					if (playspellsound ~= nil) and (playspellsound ~= "") then
						PlaySoundFile(playspellsound)
					end
				else
					local playspellsound = sPlaySound
					if (playspellsound ~= nil) and (playspellsound ~= "") then
						PlaySoundFile(playspellsound)
					end
				end
			end
			
			--self:createProcFrame(spellID)
		end
	else
		local sIcon = ''
		if (IsNumber(sID)) and (sID > 0) and (isCooldown == false) then
			_,_,sIcon = GetSpellInfo(sID)
		end
		
		ex[sName] = {
			startTime = GetTime(),
			endTime = GetTime() + sLength,
			icon = sIcon,
			color = sColor,
		}
		m:TriggerEvent("QuartzMirror_UpdateCustom")
		
		-- Play a sound if found
		if (sPlaySound ~= nil) and (sPlaySound ~= "") 
			and (string.lower(sPlaySound) ~= "none")
		then
			if useSharedMedia then
				local playspellsound = sharedMedia:Fetch("sound", sPlaySound)
				if (playspellsound ~= nil) and (playspellsound ~= "") then
					PlaySoundFile(playspellsound)
				end
			else
				local playspellsound = sPlaySound
				if (playspellsound ~= nil) and (playspellsound ~= "") then
					PlaySoundFile(playspellsound)
				end
			end
		end
				
		--self:createProcFrame(spellID)
	end
end



-- Checks each buff when Aura changes
function QuartzCustomTimer:UNIT_AURA(unit)
	if unit ~= "player" then return end
	
	for kSpellID,vSpell in pairs(spellsWatch) do
		if (vSpell.isAura) then
			local d_name = vSpell.name
			if (db.profile[kSpellID] ~= nil) and (db.profile[kSpellID].name ~= nil) then
				d_name = db.profile[kSpellID].name
			end
			local foundSpell = false
			
			for i=1,40 do
				local name,rank,icon,count,dtype,dur,expr,caster,isStealable,shouldConsolidate,spellId=UnitAura(unit,i)
				if not name then break end
				if dur and dur > 0 and expr then
					--print("vSpell.name = "..vSpell.name.."("..kSpellID..") name = "..name.."("..spellId..")")
					if ((tostring(spellId) == tostring(kSpellID))) or 
						((vSpell.useName ~= nil) and (vSpell.useName) and 
						(string.lower(vSpell.name) == string.lower(name)))
					then
						foundSpell = true
						-- some spiffy code to make it work with stacking procs
						-- TODO: show the # of stacks? (prolly wont happen until there's a "mirror" module fix
						-- TODO: slight differences so i have to do it like this (is exprDIff > 1 enough?)
						local exprDiff = math.abs(expr - vSpell.expires)
						
						if (exprDiff > 1) then -- Create TImer
							if ((count ~= nil) and (count < 1)) or
								((count ~= nil) and (count > 0)) -- and (vSpell.expires == 0))
							then
								vSpell.expires = expr
								local s_playsound = vSpell.sound or "";
								self:createCustomTimer(d_name, dur, tonumber(spellId), vSpell.color, false, s_playsound)
								
								if (vSpell.cooldown) then
									local cd_name = d_name
									--TODO: translate this
									cd_name = cd_name .. " Cooldown"
									self:createCustomTimer(cd_name, vSpell.cooldown, spellId, {1,0,0}, true, "")
								end
							end
						end
					end
				end
			end
			if (not foundSpell) then
				vSpell.expires = 0
				if (ex[d_name] ~= nil) then
					ex[d_name] = del(ex[d_name])
					m:TriggerEvent("QuartzMirror_UpdateCustom")
				end
			end
		end
	end
	
end


function QuartzCustomTimer:COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	if (destGUID == UnitGUID("player")) then --check if the player is receiving the buff
		local spellID = select(1,...)
		local spellname = select(2,...)
		if (spellID ~= nil) and (spellID ~= "") then spellID = tostring(spellID) end
		
		if (event == "SPELL_AURA_APPLIED") or (event == "SPELL_AURA_REFRESH") then
			if (spellsWatch ~= nil) and (spellsWatch[spellID] ~= nil) then
				-- Make sure it's not a spell that gets added in the UNIT_AURA event
				if (spellsWatch[spellID].isAura == nil) or (spellsWatch[spellID].isAura == false) then
					local d_name = spellsWatch[spellID].name
					if (db.profile[spellID] ~= nil) and (db.profile[spellID].name ~= nil) then
						d_name = db.profile[spellID].name
					end

					local s_playsound = spellsWatch[spellID].sound or "";
					
					--setup the oldname for stack buffs (on application)
					if (spellsWatch[spellID].isStack) and (event == "SPELL_AURA_APPLIED") then
						spellsWatch[spellID].oldname = d_name
					-- if the stacked buff gets refreshed, make sure d_name is the oldname of the spell stack
					elseif (spellsWatch[spellID].isStack) and (event == "SPELL_AURA_REFRESH") then
						d_name = spellsWatch[spellID].oldname
					end
					
					self:createCustomTimer(d_name, spellsWatch[spellID].length, tonumber(spellID), spellsWatch[spellID].color, false, s_playsound)
					
					if (spellsWatch[spellID].cooldown) then
						local cd_name = spellsWatch[spellID].name
						if (db.profile[spellID] ~= nil) and (db.profile[spellID].name ~= nil) then
							cd_name = db.profile[spellID].name
						end
						--TODO: translate this
						cd_name = cd_name .. " Cooldown"
						self:createCustomTimer(cd_name, spellsWatch[spellID].cooldown, tonumber(spellID), {1,0,0}, true, "")
					end
				end
			end
			
		-- Use this to remove procs that can be consumed (or clicked off, or dispelled)
		elseif (event == "SPELL_AURA_REMOVED") then
			if (spellsWatch ~= nil) and (spellsWatch[spellID] ~= nil) then
				local d_name = spellsWatch[spellID].name
				if (db.profile[spellID] ~= nil) and (db.profile[spellID].name ~= nil) then
					d_name = db.profile[spellID].name
				end
				-- use oldname here for stack buffs (cause they have (2) or whatever in the name)
				if (spellsWatch[spellID].isStack) then
					d_name = spellsWatch[spellID].oldname
				end
				
				if ex[d_name] ~= nil then
					ex[d_name] = del(ex[d_name])
					m:TriggerEvent("QuartzMirror_UpdateCustom")
				end
			-- hacky fix to remove by name (for different ranks that don't have a spellID in the table)
			elseif (ex[spellname] ~= nil) then
				ex[spellname] = del(ex[spellname])
				m:TriggerEvent("QuartzMirror_UpdateCustom")
			end
		
		-- this is for stacking buffs
		-- todo: this only works if the spell stacks are applied sequentily (1,2,3,4...)
		-- and only if spell stacks can't be removed (if i run into a situation that i need it
		-- to work otherwise, gotta redo this code ;( )
		elseif (event == "SPELL_AURA_APPLIED_DOSE") then
			if (spellsWatch ~= nil) and (spellsWatch[spellID] ~= nil) then
				-- Make sure it's not a spell that gets added in the UNIT_AURA event
				if (spellsWatch[spellID].isAura == nil) or (spellsWatch[spellID].isAura == false)
					and (spellsWatch[spellID].isStack == true)
				then
					local d_name = spellsWatch[spellID].name
					if (db.profile[spellID] ~= nil) and (db.profile[spellID].name ~= nil) then
						d_name = db.profile[spellID].name
					end
					local s_playsound = spellsWatch[spellID].sound or "";
					local spellStack = select(5,...)
					
					-- remove the old timer
					if (spellsWatch[spellID].oldname ~= "") then
						if (ex[spellsWatch[spellID].oldname] ~= nil) then
							ex[spellsWatch[spellID].oldname] = del(ex[spellsWatch[spellID].oldname])
							m:TriggerEvent("QuartzMirror_UpdateCustom")
						end
					end
					
					--update the spell name with the # of stacks
					d_name = d_name .. " ("..spellStack..")"
					spellsWatch[spellID].oldname = d_name
					
					self:createCustomTimer(d_name, spellsWatch[spellID].length, tonumber(spellID), spellsWatch[spellID].color, false, s_playsound)
					
					--TODO: add cooldown code here if we ever need a cooldown for stacking buffs
				end
			end
		end
		
	-- check if the spell was cast onto someone else (or nobody)
	elseif (event == "SPELL_CAST_SUCCESS") and (sourceGUID == UnitGUID("player")) then
		local spellID = select(1,...)
		local spellname = select(2,...)
		if (spellID ~= nil) and (spellID ~= "") then spellID = tostring(spellID) end
		
		if (spellsWatch ~= nil) and (spellsWatch[spellID] ~= nil) then
			if (spellsWatch[spellID].isSpellCast ~= nil)  and (spellsWatch[spellID].isSpellCast == true)
			then
				local d_name = spellsWatch[spellID].name
				if (db.profile[spellID] ~= nil) and (db.profile[spellID].name ~= nil) then
					d_name = db.profile[spellID].name
				end
				local s_playsound = spellsWatch[spellID].sound or "";
				
				self:createCustomTimer(d_name, spellsWatch[spellID].length, tonumber(spellID), spellsWatch[spellID].color, false, s_playsound)
			end
		end
	end
	
end
